import java.awt.*;
import java.awt.geom.*;

public class Linie extends Figur
{
	private int links1, links2, oben1, oben2;
	private int x1, y1, x2, y2;
	private boolean neu=true;
	public Linie()
	{
		linienbreite=3;
		links1=20;
		oben1=20;
		links2=100;
		oben2=100;
		farbe=Color.black;
		addArg(new Argument("links1","20","Anfangspunkt - Abstand vom linken Rand","x1"));
		addArg(new Argument("oben1","20","Anfangspunkt - Abstand vom oberen Rand","y1"));
		addArg(new Argument("links2","100","Endpunkt - Abstand vom linken Rand","x2"));
		addArg(new Argument("oben2","100","Endpunkt - Abstand vom oberen Rand","y2"));
		addMet(new Methode("links1Setzen(links1)","setzt den Abstand des Anfangs vom linken Rand"));
        addMet(new Methode("oben1Setzen(oben1)","setzt den Abstand des Anfangs vom oberen Rand"));
		addMet(new Methode("links2Setzen(links2)","setzt den Abstand des Endes vom linken Rand"));
        addMet(new Methode("oben2Setzen(oben2)","setzt den Abstand des Endes vom oberen Rand"));
        refresh();
	}
	public void links1Setzen(int in){
		links1=in;
	}
	public void oben1Setzen(int in){
		oben1=in;
	}
	public void links2Setzen(int in){
		links2=in;
	}
	public void oben2Setzen(int in){
		oben2=in;
	}


	public Shape getShape()
	{
		return new Line2D.Double(links1,oben1,links2,oben2);
	}
	public Dimension getMittelpunkt()
	{
		return new Dimension((int)((links1+links2)/2),(int)((oben1+oben2)/2));
	}
	public void verschiebe(int dx, int dy)
	{
		if(neu)
		{
			x1=links1*faktor;
			y1=oben1*faktor;
			x2=links2*faktor;
			y2=oben2*faktor;
			neu=false;
		}
		x1+=dx*faktor;
		y1+=dy*faktor;
		x2+=dx*faktor;
		y2+=dy*faktor;
		links1+=dx;
		oben1+=dy;
		links2+=dx;
		oben2+=dy;
	}
	public void verschiebe1(int dx, int dy)
	{
		if(neu)
		{
			x1=links1*faktor;
			y1=oben1*faktor;
			x2=links2*faktor;
			y2=oben2*faktor;
			neu=false;
		}
		x1+=dx;
		y1+=dy;
		x2+=dx;
		y2+=dy;
		links1=(int)x1/faktor;
		oben1=(int)y1/faktor;
		links2=(int)x2/faktor;
		oben2=(int)y2/faktor;
	}
	public void setGrenzen()
	{
		xmin=Math.min(links1,links2);
		xmax=Math.max(links1,links2);
		ymin=Math.min(oben1,oben2);
		ymax=Math.max(oben1,oben2);
	}

}
