import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.*;

public class Objektkarte extends Panel implements ActionListener, MouseListener
{
	Karte karte;
	TextArea text;
	JTextField name;
	JComboBox cb;
	JTextField[] arguments;
	Bild bild;
	int x1=0;
	int y1=0;
	int x2=0;
	int y2=0;
	int xmin=0;
	int ymin=0;
	int xmax=0;
	int ymax=0;
	int dx=0;
	int dy=0;
	int adx=0;
	int ady=0;
	int r=0;
	JPanel container;
	Panel oval;
	String ttt="Position und Groesse des Objekts koennen mit der Maus aus dem Zeichenfeld gewonnen werden.";
	Argument[] argumente;

	public Objektkarte(Bild bild, TextArea text)
	{
		this.bild=bild;
		this.text=text;
		setVisible(false);
		setLayout(new BorderLayout(20,20));

		JLabel Ueberschrift=new JLabel("  Objektkarte ausfuellen:",JLabel.LEFT);
		Ueberschrift.setToolTipText(ttt);
		Ueberschrift.setFont(new Font("SansSerif",Font.BOLD,12));
		JLabel Ueberschft=Ueberschrift;
		add("North",Ueberschft);

		oval=new Panel(){public void paint(Graphics g){
			g.setColor(Color.lightGray);
			g.fillRoundRect(5,5,getSize().width-10,getSize().height-10,30,30);
			g.setColor(Color.black);
			g.drawRoundRect(5,5,getSize().width-10,getSize().height-10,30,30);
			super.paint(g);
			int y=(int)(container.getComponent(2).getBounds().getY()+container.getBounds().getY()-3);
			g.drawLine(5,y,getSize().width-5,y);
		}};
		oval.setLayout(new BorderLayout(20,20));
		add("Center",oval);
		container=new JPanel();
		container.setBackground(Color.lightGray);
		oval.add("Center",container);
		oval.add("North",new Panel(){public Dimension getPreferredSize(){return new Dimension(0,0);}});
		oval.add("South",new Panel(){public Dimension getPreferredSize(){return new Dimension(0,0);}});
		oval.add("West",new Panel(){public Dimension getPreferredSize(){return new Dimension(0,0);}});
		oval.add("East",new Panel(){public Dimension getPreferredSize(){return new Dimension(0,0);}});

		Container buts=new Container();
		add("South",buts);
		buts.setLayout(new GridLayout(3,1));

		Container butsOben=new Container();
		buts.add(butsOben);
		butsOben.setLayout(new GridLayout(1,2));
		JButton ok=new JButton("uebernehmen");
		ok.setActionCommand("ok");
		ok.addActionListener(this);
		butsOben.add(ok);

		JButton abbrechen=new JButton("abbrechen");
		abbrechen.setActionCommand("abbrechen");
		abbrechen.addActionListener(this);
		butsOben.add(abbrechen);

		JButton zeichnen=new JButton("Uebernehmen und ganzes Bild neu zeichnen");
		zeichnen.setActionCommand("zeichnen");
		zeichnen.addActionListener(this);
		buts.add(zeichnen);

		JButton zeichneA=new JButton("hinzufuegen und zeichnen");
		zeichneA.setActionCommand("ausschnitt");
		zeichneA.addActionListener(this);
		buts.add(zeichneA);

		ok.setToolTipText("Das Objekt wird in das Programmfenster uebernommen, aber nicht gezeichnet.");
		abbrechen.setToolTipText("Ohne Aebderungen abbrechen.");
		zeichnen.setToolTipText("Das Objekt wird Uebernommen und das ganze Bild neu gezeichnet (Bewegungen werden zurueckgesetzt).");
		zeichneA.setToolTipText("Das Objekt wird in das Programmfenster uebernommen und gezeichnet, der Rest der Zeichnung bleibt unangetastet.");
	}
	private void ende()
	{
		this.setVisible(false);
	}

	public void setKarte(Karte k)
	{
		setVisible(true);
		oval.remove(container);
		karte=k;
		argumente=karte.getArgumente();
		Class c=karte.f.getClass();

		container=new JPanel();
		oval.add("Center",container);
		container.setLayout(new GridLayout(argumente.length+1,2,6,6));
		container.setBackground(Color.lightGray);
		name=new JTextField();
		name.setHorizontalAlignment(JTextField.RIGHT);
		Figur.incNummer();
		name.setText("objekt"+Figur.getNummer());
		container.add(name);
		JLabel l;
		l=new JLabel(" :  "+c.getName());
		name.setToolTipText("Bezeichner des Objekts");
		container.add(l);
		l.setBackground(Color.lightGray);
		l.setFont(new Font("SansSerif",Font.BOLD,12));

		JLabel fa=new JLabel(argumente[0].name+":   ",JLabel.RIGHT);
		fa.setBackground(Color.lightGray);
		fa.setToolTipText(ttt);
		container.add(fa);
		cb=new JComboBox(bild.getFarben());
		cb.setToolTipText(argumente[0].beschreibung);
		container.add(cb);
		arguments=new JTextField[argumente.length-1];
		for(int i=0;i<argumente.length-1;i++)
		{
			JLabel la=new JLabel(argumente[i+1].name+":   ",JLabel.RIGHT);
			la.setBackground(Color.lightGray);
			la.setToolTipText(ttt);
			container.add(la);
			arguments[i]=new JTextField();
			arguments[i].setToolTipText(argumente[i+1].beschreibung);
			container.add(arguments[i]);
			arguments[i].setText(argumente[i+1].vorgabe);
		}
		validate();
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equals("ok"))
		{
			bild.setFadenkreuz(false);
			uebernehmen();
			ende();
		}

		if(e.getActionCommand().equals("zeichnen"))
		{
			bild.setFadenkreuz(false);
			uebernehmen();
			zeichnen();
			ende();
		}
		if(e.getActionCommand().equals("ausschnitt"))
		{
			bild.setFadenkreuz(false);
			uebernehmen();
			zeichneAusschnitt();
			ende();
		}

		if(e.getActionCommand().equals("abbrechen"))
		{
			bild.setFadenkreuz(false);
			ende();
		}
	}

	private void uebernehmen()
	{

//		int anfang=text.getText().length();
StringBuffer befehl=new StringBuffer();
		String nam=name.getText();
		String obj = karte.getName();
//		text.append(nam+"=new "+obj+"();\r\n");
befehl.append(nam+"=new "+obj+"();\r\n");
		String argument=argumente[0].name;
//		text.append(nam+"."+argument+" = "+cb.getSelectedItem()+";\r\n");
befehl.append(nam+"."+argument+"Setzen("+cb.getSelectedItem()+");\r\n");
		for(int i = 0; i<argumente.length-1;i++)
		{
			argument=argumente[i+1].name;
//			text.append(nam+"."+argument+" = "+arguments[i].getText()+";\r\n");
befehl.append(nam+"."+argument+"Setzen("+arguments[i].getText()+");\r\n");
		}
//		int ende=text.getText().length();
//		text.setSelectionStart(anfang);
//		text.setSelectionEnd(ende);

//text.setCaretPosition(text.getText().length());
//int anfang=text.getText().length();//text.getCaretPosition();

text.append(befehl.toString());
bild.befehl=befehl.toString();
//text.setCaretPosition(text.getText().length());
//int ende=text.getText().length();//text.getCaretPosition();
//text.select(anfang,ende);
//	text.setSelectionStart(anfang);
//	text.setSelectionEnd(ende);



	}

	private void zeichnen()
	{
		bild.neuzeichnen();
	}
	private void zeichneAusschnitt()
	{
//		bild.zeichneAusschnitt();
bild.befehlAusfuehren();
	}

	public void mouseClicked(MouseEvent e)
	{
	}
	public void mousePressed(MouseEvent e)
	{
		x1=e.getX();
		y1=e.getY();

	}
	public void mouseReleased(MouseEvent e)
	{
		x2=e.getX();
		y2=e.getY();
		xmin=Math.min(x1,x2);
		xmax=Math.max(x1,x2);
		ymin=Math.min(y1,y2);
		ymax=Math.max(y1,y2);
		dx=x2-x1;
		dy=y2-y1;
		adx=Math.abs(dx);
		ady=Math.abs(dy);
		r=(int)(Math.max(adx,ady)/2);

		if(karte!=null)
		{
			for(int i=0;i<argumente.length-1;i++)
			{
				int j = i+1;
				if(argumente[j].maus.equals("x1"))
				{
					arguments[i].setText(""+x1);
				}
				if(argumente[j].maus.equals("y1"))
				{
					arguments[i].setText(""+y1);
				}
				if(argumente[j].maus.equals("x2"))
				{
					arguments[i].setText(""+x2);
				}
				if(argumente[j].maus.equals("y2"))
				{
					arguments[i].setText(""+y2);
				}
				if(argumente[j].maus.equals("xmin"))
				{
					arguments[i].setText(""+xmin);
				}
				if(argumente[j].maus.equals("ymin"))
				{
					arguments[i].setText(""+ymin);
				}
				if(argumente[j].maus.equals("xmax"))
				{
					arguments[i].setText(""+xmax);
				}
				if(argumente[j].maus.equals("ymax"))
				{
					arguments[i].setText(""+ymax);
				}
				if(argumente[j].maus.equals("dx"))
				{
					arguments[i].setText(""+dx);
				}
				if(argumente[j].maus.equals("dy"))
				{
					arguments[i].setText(""+dy);
				}
				if(argumente[j].maus.equals("adx"))
				{
					arguments[i].setText(""+adx);
				}
				if(argumente[j].maus.equals("ady"))
				{
					arguments[i].setText(""+ady);
				}
				if(argumente[j].maus.equals("r"))
				{
					arguments[i].setText(""+r);
				}
			}
		}
	}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
}
