import java.awt.*;
import java.awt.event.*;

public class SchriftPopup extends PopupMenu implements ActionListener, MouseListener
{
	private SchriftListener sl;

	public SchriftPopup(SchriftListener sl)
	{
		this.sl=sl;
		MenuItem m=new MenuItem("Schrift groesser");
		m.setActionCommand("g");
		m.addActionListener(this);
		add(m);
		m=new MenuItem("Schrift kleiner");
		m.setActionCommand("k");
		m.addActionListener(this);
		add(m);
	}
	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equals("g"))
		{
			sl.setSchriftgroesse((int)(sl.getSchriftgroesse()*1.15));
		}
		if(e.getActionCommand().equals("k"))
		{
			sl.setSchriftgroesse((int)(1+sl.getSchriftgroesse()/1.15));
		}
	}

	public void mouseClicked(MouseEvent e){}
	public void mousePressed(MouseEvent e){}
	public void mouseReleased(MouseEvent e)
	{
		if(e.isPopupTrigger())
		{
			show((Karte)sl,e.getX(),e.getY());
		}
	}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}

}
