import java.awt.*;
import java.awt.geom.*;

public class Kreis extends Figur
{
	private int radius, oben, links;
	private int x, y;
	private boolean neu=true;

	public Kreis()
	{
		links=30;
		oben=30;
		radius=50;
		farbe=Color.black;

		addArg(new Argument("links","30","Abstand vom linken Rand","xmin"));
		addArg(new Argument("oben","30","Abstand vom oberen Rand","ymin"));
		addArg(new Argument("radius","50","Radius des Kreises","r"));
		addMet(new Methode("linksSetzen(links)","setzt den Abstand des Objekts vom linken Rand"));
        addMet(new Methode("obenSetzen(oben)","setzt den Abstand des Objekts vom oberen Rand"));
        addMet(new Methode("radiusSetzen(radius)","setzt den Radius des Kreises"));
        refresh();
	}
	public void linksSetzen(int in){
		links=in;
	}
	public void obenSetzen(int in){
		oben=in;
	}
	public void radiusSetzen(int in){
		radius=in;
	}
	
	public Shape getShape()
	{
		return new Ellipse2D.Double(links,oben,2*radius,2*radius);
	}
	public Dimension getMittelpunkt()
	{
		return new Dimension(links+radius,oben+radius);
	}
	public void verschiebe(int dx, int dy)
	{
		if(neu)
		{
			x=links*faktor;
			y=oben*faktor;
			neu=false;
		}
		x+=dx*faktor;
		y+=dy*faktor;
		links+=dx;
		oben+=dy;
	}
	public void verschiebe1(int dx, int dy)
	{
		if(neu)
		{
			x=links*faktor;
			y=oben*faktor;
			neu=false;
		}
		x+=dx;
		y+=dy;
		links=(int)x/faktor;
		oben=(int)y/faktor;
	}
	public void setGrenzen()
	{
		xmin=links;
		xmax=links+2*radius;
		ymin=oben;
		ymax=oben+2*radius;
	}

}
