import java.awt.*;
import java.awt.geom.*;

public class Rechteck extends Figur
{
    private int breite, hoehe, oben, links;
    private int x, y;
    private boolean neu=true;
    public Rechteck()
    {
        links=10;
        oben=10;
        hoehe=50;
        breite=50;
        farbe=Color.black;

        addArg(new Argument("links","10","Abstand vom linken Rand","xmin"));
        addArg(new Argument("oben","10","Abstand vom oberen Rand","ymin"));
        addArg(new Argument("breite","50","Breite des Rechtecks","adx"));
        addArg(new Argument("hoehe","50","Hoehe des Rechtecks","ady"));
        addMet(new Methode("linksSetzen(links)","setzt den Abstand des Objekts vom linken Rand"));
        addMet(new Methode("obenSetzen(oben)","setzt den Abstand des Objekts vom oberen Rand"));
        addMet(new Methode("breiteSetzen(breite)","setzt die Breite des Rechtecks"));
        addMet(new Methode("hoeheSetzen(hoehe)","setzt die Hoehe des Rechtecks"));
        refresh();
    }
	public void linksSetzen(int in){
		links=in;
	}
	public void obenSetzen(int in){
		oben=in;
	}
	public void breiteSetzen(int in){
		breite=in;
	}
	public void hoeheSetzen(int in){
		hoehe=in;
	}

    public Shape getShape()
    {
        return new Rectangle2D.Double(links,oben,breite,hoehe);
    }
    public Dimension getMittelpunkt()
    {
        return new Dimension(links+(int)(breite/2),oben+(int)(hoehe/2));
    }
    public void verschiebe(int dx, int dy)
    {
        if(neu)
        {
            x=links*faktor;
            y=oben*faktor;
            neu=false;
        }
        x+=dx*faktor;
        y+=dy*faktor;
        links+=dx;
        oben+=dy;
    }
    public void verschiebe1(int dx, int dy)
    {
        if(neu)
        {
            x=links*faktor;
            y=oben*faktor;
            neu=false;
        }
        x+=dx;
        y+=dy;
        links=(int)x/faktor;
        oben=(int)y/faktor;
    }
    public void setGrenzen()
    {
        xmin=links;
        xmax=links+breite;
        ymin=oben;
        ymax=oben+hoehe;
    }
}
